=== debian/changelog ===
corsix-th (0.60-1) unstable; urgency=medium

  [ Alexandre Detiste ]
  * New upstream release.

  [ Phil Morrell ]
  * drop all non-debian patches merged upstream
  * backport include_campaigns.patch pushed upstream
  * backport editor_drag_performance.patch for usability
  * drop obsolete lintian-overrides
  * bump Standards-Version
  * add new project website URL
  * add copyright for new campaign by ChrizmanTV
  * update main copyright authors from LICENSE.txt

 -- Phil Morrell <debian@emorrp1.name>  Wed, 22 Jun 2016 23:05:26 +0100

corsix-th (0.50-2) unstable; urgency=medium

  * backport upstream patch to build with ffmpeg 3.0 (Closes: #821415)
  * use v4 watch file to include pre-releases
  * wrap-and-sort -satb

 -- Phil Morrell <debian@emorrp1.name>  Mon, 18 Apr 2016 19:20:40 +0100

corsix-th (0.50-1) unstable; urgency=medium

  * Initial release. (Closes: #610087)

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Mon, 29 Feb 2016 15:05:38 +0100
