=== debian/control ===
Source: corsix-th
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Alexandre Detiste <alexandre.detiste@gmail.com>,
 Phil Morrell <debian@emorrp1.name>,
Build-Depends:
 cmake,
 debhelper (>= 9),
 imagemagick,
 libavdevice-dev (>= 7:2.8),
 libfreetype6-dev,
 liblua5.2-dev,
 libsdl2-dev,
 libsdl2-mixer-dev,
 lua5.2,
Standards-Version: 3.9.8
Homepage: http://corsixth.com
Vcs-Git: https://anonscm.debian.org/git/pkg-games/corsix-th.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/corsix-th.git

Package: corsix-th
Architecture: any
Depends:
 corsix-th-data (= ${source:Version}),
 lua-filesystem,
 lua-lpeg,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 theme-hospital-data | theme-hospital-demo-data | game-data-packager,
Description: Open source clone of Theme Hospital
 Theme Hospital was a simulation computer game developed by Bullfrog
 Productions and published by Electronic Arts in 1997, in which the player
 designs and operates a hospital.
 .
 The game currently requires the original graphics and tries to mimic the
 original as closely as possible. Therefore you will need a copy of the
 original game for this package to be useful.

Package: corsix-th-data
Architecture: all
Depends:
 ${misc:Depends},
Description: Open source clone of Theme Hospital (data package)
 Theme Hospital was a simulation computer game developed by Bullfrog
 Productions and published by Electronic Arts in 1997, in which the player
 designs and operates a hospital.
 .
 The game currently requires the original graphics and tries to mimic the
 original as closely as possible. Therefore you will need a copy of the
 original game for this package to be useful.
 .
 (This package contains the data files)
