=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel --buildsystem=cmake

override_dh_auto_install:
	dh_auto_install
	rm debian/tmp/usr/CorsixTH/CorsixTH.ico
	rm debian/tmp/usr/CorsixTH/LICENSE.txt

	mkdir -p debian/corsix-th/usr/lib/games/corsix-th/
	mv debian/tmp/usr/CorsixTH/CorsixTH debian/corsix-th/usr/lib/games/corsix-th/

	for size in $$(identify ico:CorsixTH/CorsixTH.ico | awk '{print $$3}'); \
	do \
		mkdir -p debian/corsix-th/usr/share/icons/hicolor/$$size/apps/ ; \
		convert ico:`identify ico:CorsixTH/CorsixTH.ico | sed -n "/ $$size /s/^.*=>\(CorsixTH\/CorsixTH.ico\[[0-9]\+]\) .*/\1/gp"` \
			-verbose debian/corsix-th/usr/share/icons/hicolor/$$size/apps/corsix-th.png ; \
	done

	mkdir -p debian/corsix-th/usr/share/icons/hicolor/scalable/apps/
	install -m0644 CorsixTH/Original_Logo.svg debian/corsix-th/usr/share/icons/hicolor/scalable/apps/corsix-th.svg

	mkdir -p debian/corsix-th-data/usr/share/games/corsix-th/
	mv debian/tmp/usr/CorsixTH/* debian/corsix-th-data/usr/share/games/corsix-th/

override_dh_installchangelogs:
	dh_installchangelogs CorsixTH/changelog.txt
