=== debian/watch ===
version=4
opts="uversionmangle=s/-/~/" \
 https://github.com/CorsixTH/CorsixTH/tags \
 (?:.*/)?v(\d[\-+\.:\~\da-zA-Z]*)@ARCHIVE_EXT@
