=== debian/changelog ===
corsix-th (0.61-1) unstable; urgency=medium

  [ Alexandre Detiste ]
  * New upstream version 0.61

  [ Phil Morrell ]
  * add pedantic lintian overrides
  * use https copyright-format url for policy v4.0.0
  * bump Standards-Version, no changes needed
  * add upstream signature to verify releases
  * drop patches released upstream
  * update main copyright authors from LICENSE.txt
  * Change Vcs-* to point to salsa.debian.org

 -- Phil Morrell <debian@emorrp1.name>  Thu, 11 Jan 2018 22:42:02 +0000

corsix-th (0.60-2) unstable; urgency=medium

  * remove obsolete rnc.pp copyright comment.
    Thanks to Alexandre Detiste
  * enable unit tests with newly packaged lua-busted
  * more flexible tag matching in debian/watch
  * bump debhelper compat to 10

 -- Phil Morrell <debian@emorrp1.name>  Tue, 15 Nov 2016 18:08:55 +0000
