=== debian/control ===
--- 
+++ 
@@ -7,18 +7,19 @@
  Phil Morrell <debian@emorrp1.name>,
 Build-Depends:
  cmake,
- debhelper (>= 9),
+ debhelper (>= 10),
  imagemagick,
  libavdevice-dev (>= 7:2.8),
  libfreetype6-dev,
  liblua5.2-dev,
  libsdl2-dev,
  libsdl2-mixer-dev,
+ lua-busted,
  lua5.2,
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Homepage: http://corsixth.com
-Vcs-Git: https://anonscm.debian.org/git/pkg-games/corsix-th.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/corsix-th.git
+Vcs-Git: https://salsa.debian.org/games-team/corsix-th.git
+Vcs-Browser: https://salsa.debian.org/games-team/corsix-th
 
 Package: corsix-th
 Architecture: any
