=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --parallel --buildsystem=cmake
+	dh $@
 
 override_dh_auto_install:
 	dh_auto_install
@@ -26,5 +26,9 @@
 	mkdir -p debian/corsix-th-data/usr/share/games/corsix-th/
 	mv debian/tmp/usr/CorsixTH/* debian/corsix-th-data/usr/share/games/corsix-th/
 
+override_dh_auto_test:
+	dh_auto_test
+	busted -C CorsixTH/Luatest --verbose
+
 override_dh_installchangelogs:
 	dh_installchangelogs CorsixTH/changelog.txt
