=== debian/watch ===
version=4
opts=uversionmangle=s/-/~/,\
pgpsigurlmangle=s`archive/v@ANY_VERSION@(@ARCHIVE_EXT@)`releases/download/v$1/CorsixTH-$1$2\.asc` \
 https://github.com/CorsixTH/CorsixTH/tags \
 (?:.*/)?v?@ANY_VERSION@@ARCHIVE_EXT@
